git-rebase--interactive.shon commit Add tests for rebase -i --root without --onto (b64b7fe)
   1#!/bin/sh
   2#
   3# Copyright (c) 2006 Johannes E. Schindelin
   4
   5# SHORT DESCRIPTION
   6#
   7# This script makes it easy to fix up commits in the middle of a series,
   8# and rearrange commits.
   9#
  10# The original idea comes from Eric W. Biederman, in
  11# http://article.gmane.org/gmane.comp.version-control.git/22407
  12
  13. git-sh-setup
  14
  15# The file containing rebase commands, comments, and empty lines.
  16# This file is created by "git rebase -i" then edited by the user.  As
  17# the lines are processed, they are removed from the front of this
  18# file and written to the tail of $done.
  19todo="$state_dir"/git-rebase-todo
  20
  21# The rebase command lines that have already been processed.  A line
  22# is moved here when it is first handled, before any associated user
  23# actions.
  24done="$state_dir"/done
  25
  26# The commit message that is planned to be used for any changes that
  27# need to be committed following a user interaction.
  28msg="$state_dir"/message
  29
  30# The file into which is accumulated the suggested commit message for
  31# squash/fixup commands.  When the first of a series of squash/fixups
  32# is seen, the file is created and the commit message from the
  33# previous commit and from the first squash/fixup commit are written
  34# to it.  The commit message for each subsequent squash/fixup commit
  35# is appended to the file as it is processed.
  36#
  37# The first line of the file is of the form
  38#     # This is a combination of $count commits.
  39# where $count is the number of commits whose messages have been
  40# written to the file so far (including the initial "pick" commit).
  41# Each time that a commit message is processed, this line is read and
  42# updated.  It is deleted just before the combined commit is made.
  43squash_msg="$state_dir"/message-squash
  44
  45# If the current series of squash/fixups has not yet included a squash
  46# command, then this file exists and holds the commit message of the
  47# original "pick" commit.  (If the series ends without a "squash"
  48# command, then this can be used as the commit message of the combined
  49# commit without opening the editor.)
  50fixup_msg="$state_dir"/message-fixup
  51
  52# $rewritten is the name of a directory containing files for each
  53# commit that is reachable by at least one merge base of $head and
  54# $upstream. They are not necessarily rewritten, but their children
  55# might be.  This ensures that commits on merged, but otherwise
  56# unrelated side branches are left alone. (Think "X" in the man page's
  57# example.)
  58rewritten="$state_dir"/rewritten
  59
  60dropped="$state_dir"/dropped
  61
  62# A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
  63# GIT_AUTHOR_DATE that will be used for the commit that is currently
  64# being rebased.
  65author_script="$state_dir"/author-script
  66
  67# When an "edit" rebase command is being processed, the SHA1 of the
  68# commit to be edited is recorded in this file.  When "git rebase
  69# --continue" is executed, if there are any staged changes then they
  70# will be amended to the HEAD commit, but only provided the HEAD
  71# commit is still the commit to be edited.  When any other rebase
  72# command is processed, this file is deleted.
  73amend="$state_dir"/amend
  74
  75# For the post-rewrite hook, we make a list of rewritten commits and
  76# their new sha1s.  The rewritten-pending list keeps the sha1s of
  77# commits that have been processed, but not committed yet,
  78# e.g. because they are waiting for a 'squash' command.
  79rewritten_list="$state_dir"/rewritten-list
  80rewritten_pending="$state_dir"/rewritten-pending
  81
  82GIT_CHERRY_PICK_HELP="$resolvemsg"
  83export GIT_CHERRY_PICK_HELP
  84
  85warn () {
  86        printf '%s\n' "$*" >&2
  87}
  88
  89# Output the commit message for the specified commit.
  90commit_message () {
  91        git cat-file commit "$1" | sed "1,/^$/d"
  92}
  93
  94orig_reflog_action="$GIT_REFLOG_ACTION"
  95
  96comment_for_reflog () {
  97        case "$orig_reflog_action" in
  98        ''|rebase*)
  99                GIT_REFLOG_ACTION="rebase -i ($1)"
 100                export GIT_REFLOG_ACTION
 101                ;;
 102        esac
 103}
 104
 105last_count=
 106mark_action_done () {
 107        sed -e 1q < "$todo" >> "$done"
 108        sed -e 1d < "$todo" >> "$todo".new
 109        mv -f "$todo".new "$todo"
 110        new_count=$(sane_grep -c '^[^#]' < "$done")
 111        total=$(($new_count+$(sane_grep -c '^[^#]' < "$todo")))
 112        if test "$last_count" != "$new_count"
 113        then
 114                last_count=$new_count
 115                printf "Rebasing (%d/%d)\r" $new_count $total
 116                test -z "$verbose" || echo
 117        fi
 118}
 119
 120make_patch () {
 121        sha1_and_parents="$(git rev-list --parents -1 "$1")"
 122        case "$sha1_and_parents" in
 123        ?*' '?*' '?*)
 124                git diff --cc $sha1_and_parents
 125                ;;
 126        ?*' '?*)
 127                git diff-tree -p "$1^!"
 128                ;;
 129        *)
 130                echo "Root commit"
 131                ;;
 132        esac > "$state_dir"/patch
 133        test -f "$msg" ||
 134                commit_message "$1" > "$msg"
 135        test -f "$author_script" ||
 136                get_author_ident_from_commit "$1" > "$author_script"
 137}
 138
 139die_with_patch () {
 140        echo "$1" > "$state_dir"/stopped-sha
 141        make_patch "$1"
 142        git rerere
 143        die "$2"
 144}
 145
 146exit_with_patch () {
 147        echo "$1" > "$state_dir"/stopped-sha
 148        make_patch $1
 149        git rev-parse --verify HEAD > "$amend"
 150        warn "You can amend the commit now, with"
 151        warn
 152        warn "  git commit --amend"
 153        warn
 154        warn "Once you are satisfied with your changes, run"
 155        warn
 156        warn "  git rebase --continue"
 157        warn
 158        exit $2
 159}
 160
 161die_abort () {
 162        rm -rf "$state_dir"
 163        die "$1"
 164}
 165
 166has_action () {
 167        sane_grep '^[^#]' "$1" >/dev/null
 168}
 169
 170is_empty_commit() {
 171        tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null ||
 172                die "$1: not a commit that can be picked")
 173        ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null ||
 174                ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904)
 175        test "$tree" = "$ptree"
 176}
 177
 178# Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
 179# GIT_AUTHOR_DATE exported from the current environment.
 180do_with_author () {
 181        (
 182                export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 183                "$@"
 184        )
 185}
 186
 187git_sequence_editor () {
 188        if test -z "$GIT_SEQUENCE_EDITOR"
 189        then
 190                GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
 191                if [ -z "$GIT_SEQUENCE_EDITOR" ]
 192                then
 193                        GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
 194                fi
 195        fi
 196
 197        eval "$GIT_SEQUENCE_EDITOR" '"$@"'
 198}
 199
 200pick_one () {
 201        ff=--ff
 202
 203        case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
 204        case "$force_rebase" in '') ;; ?*) ff= ;; esac
 205        output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
 206
 207        if is_empty_commit "$sha1"
 208        then
 209                empty_args="--allow-empty"
 210        fi
 211
 212        test -d "$rewritten" &&
 213                pick_one_preserving_merges "$@" && return
 214        output git cherry-pick $empty_args $ff "$@"
 215}
 216
 217pick_one_preserving_merges () {
 218        fast_forward=t
 219        case "$1" in
 220        -n)
 221                fast_forward=f
 222                sha1=$2
 223                ;;
 224        *)
 225                sha1=$1
 226                ;;
 227        esac
 228        sha1=$(git rev-parse $sha1)
 229
 230        if test -f "$state_dir"/current-commit
 231        then
 232                if test "$fast_forward" = t
 233                then
 234                        while read current_commit
 235                        do
 236                                git rev-parse HEAD > "$rewritten"/$current_commit
 237                        done <"$state_dir"/current-commit
 238                        rm "$state_dir"/current-commit ||
 239                        die "Cannot write current commit's replacement sha1"
 240                fi
 241        fi
 242
 243        echo $sha1 >> "$state_dir"/current-commit
 244
 245        # rewrite parents; if none were rewritten, we can fast-forward.
 246        new_parents=
 247        pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
 248        if test "$pend" = " "
 249        then
 250                pend=" root"
 251        fi
 252        while [ "$pend" != "" ]
 253        do
 254                p=$(expr "$pend" : ' \([^ ]*\)')
 255                pend="${pend# $p}"
 256
 257                if test -f "$rewritten"/$p
 258                then
 259                        new_p=$(cat "$rewritten"/$p)
 260
 261                        # If the todo reordered commits, and our parent is marked for
 262                        # rewriting, but hasn't been gotten to yet, assume the user meant to
 263                        # drop it on top of the current HEAD
 264                        if test -z "$new_p"
 265                        then
 266                                new_p=$(git rev-parse HEAD)
 267                        fi
 268
 269                        test $p != $new_p && fast_forward=f
 270                        case "$new_parents" in
 271                        *$new_p*)
 272                                ;; # do nothing; that parent is already there
 273                        *)
 274                                new_parents="$new_parents $new_p"
 275                                ;;
 276                        esac
 277                else
 278                        if test -f "$dropped"/$p
 279                        then
 280                                fast_forward=f
 281                                replacement="$(cat "$dropped"/$p)"
 282                                test -z "$replacement" && replacement=root
 283                                pend=" $replacement$pend"
 284                        else
 285                                new_parents="$new_parents $p"
 286                        fi
 287                fi
 288        done
 289        case $fast_forward in
 290        t)
 291                output warn "Fast-forward to $sha1"
 292                output git reset --hard $sha1 ||
 293                        die "Cannot fast-forward to $sha1"
 294                ;;
 295        f)
 296                first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
 297
 298                if [ "$1" != "-n" ]
 299                then
 300                        # detach HEAD to current parent
 301                        output git checkout $first_parent 2> /dev/null ||
 302                                die "Cannot move HEAD to $first_parent"
 303                fi
 304
 305                case "$new_parents" in
 306                ' '*' '*)
 307                        test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
 308
 309                        # redo merge
 310                        author_script_content=$(get_author_ident_from_commit $sha1)
 311                        eval "$author_script_content"
 312                        msg_content="$(commit_message $sha1)"
 313                        # No point in merging the first parent, that's HEAD
 314                        new_parents=${new_parents# $first_parent}
 315                        if ! do_with_author output \
 316                                git merge --no-ff ${strategy:+-s $strategy} -m \
 317                                        "$msg_content" $new_parents
 318                        then
 319                                printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
 320                                die_with_patch $sha1 "Error redoing merge $sha1"
 321                        fi
 322                        echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
 323                        ;;
 324                *)
 325                        output git cherry-pick "$@" ||
 326                                die_with_patch $sha1 "Could not pick $sha1"
 327                        ;;
 328                esac
 329                ;;
 330        esac
 331}
 332
 333nth_string () {
 334        case "$1" in
 335        *1[0-9]|*[04-9]) echo "$1"th;;
 336        *1) echo "$1"st;;
 337        *2) echo "$1"nd;;
 338        *3) echo "$1"rd;;
 339        esac
 340}
 341
 342update_squash_messages () {
 343        if test -f "$squash_msg"; then
 344                mv "$squash_msg" "$squash_msg".bak || exit
 345                count=$(($(sed -n \
 346                        -e "1s/^# This is a combination of \(.*\) commits\./\1/p" \
 347                        -e "q" < "$squash_msg".bak)+1))
 348                {
 349                        echo "# This is a combination of $count commits."
 350                        sed -e 1d -e '2,/^./{
 351                                /^$/d
 352                        }' <"$squash_msg".bak
 353                } >"$squash_msg"
 354        else
 355                commit_message HEAD > "$fixup_msg" || die "Cannot write $fixup_msg"
 356                count=2
 357                {
 358                        echo "# This is a combination of 2 commits."
 359                        echo "# The first commit's message is:"
 360                        echo
 361                        cat "$fixup_msg"
 362                } >"$squash_msg"
 363        fi
 364        case $1 in
 365        squash)
 366                rm -f "$fixup_msg"
 367                echo
 368                echo "# This is the $(nth_string $count) commit message:"
 369                echo
 370                commit_message $2
 371                ;;
 372        fixup)
 373                echo
 374                echo "# The $(nth_string $count) commit message will be skipped:"
 375                echo
 376                commit_message $2 | sed -e 's/^/#       /'
 377                ;;
 378        esac >>"$squash_msg"
 379}
 380
 381peek_next_command () {
 382        sed -n -e "/^#/d" -e '/^$/d' -e "s/ .*//p" -e "q" < "$todo"
 383}
 384
 385# A squash/fixup has failed.  Prepare the long version of the squash
 386# commit message, then die_with_patch.  This code path requires the
 387# user to edit the combined commit message for all commits that have
 388# been squashed/fixedup so far.  So also erase the old squash
 389# messages, effectively causing the combined commit to be used as the
 390# new basis for any further squash/fixups.  Args: sha1 rest
 391die_failed_squash() {
 392        mv "$squash_msg" "$msg" || exit
 393        rm -f "$fixup_msg"
 394        cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
 395        warn
 396        warn "Could not apply $1... $2"
 397        die_with_patch $1 ""
 398}
 399
 400flush_rewritten_pending() {
 401        test -s "$rewritten_pending" || return
 402        newsha1="$(git rev-parse HEAD^0)"
 403        sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
 404        rm -f "$rewritten_pending"
 405}
 406
 407record_in_rewritten() {
 408        oldsha1="$(git rev-parse $1)"
 409        echo "$oldsha1" >> "$rewritten_pending"
 410
 411        case "$(peek_next_command)" in
 412        squash|s|fixup|f)
 413                ;;
 414        *)
 415                flush_rewritten_pending
 416                ;;
 417        esac
 418}
 419
 420do_pick () {
 421        if test "$(git rev-parse HEAD)" = "$squash_onto"
 422        then
 423                # Set the correct commit message and author info on the
 424                # sentinel root before cherry-picking the original changes
 425                # without committing (-n).  Finally, update the sentinel again
 426                # to include these changes.  If the cherry-pick results in a
 427                # conflict, this means our behaviour is similar to a standard
 428                # failed cherry-pick during rebase, with a dirty index to
 429                # resolve before manually running git commit --amend then git
 430                # rebase --continue.
 431                git commit --allow-empty --allow-empty-message --amend \
 432                           --no-post-rewrite -n -q -C $1 &&
 433                        pick_one -n $1 &&
 434                        git commit --allow-empty --allow-empty-message \
 435                                   --amend --no-post-rewrite -n -q -C $1 ||
 436                        die_with_patch $1 "Could not apply $1... $2"
 437        else
 438                pick_one $1 ||
 439                        die_with_patch $1 "Could not apply $1... $2"
 440        fi
 441}
 442
 443do_next () {
 444        rm -f "$msg" "$author_script" "$amend" || exit
 445        read -r command sha1 rest < "$todo"
 446        case "$command" in
 447        '#'*|''|noop)
 448                mark_action_done
 449                ;;
 450        pick|p)
 451                comment_for_reflog pick
 452
 453                mark_action_done
 454                do_pick $sha1 "$rest"
 455                record_in_rewritten $sha1
 456                ;;
 457        reword|r)
 458                comment_for_reflog reword
 459
 460                mark_action_done
 461                do_pick $sha1 "$rest"
 462                git commit --amend --no-post-rewrite || {
 463                        warn "Could not amend commit after successfully picking $sha1... $rest"
 464                        warn "This is most likely due to an empty commit message, or the pre-commit hook"
 465                        warn "failed. If the pre-commit hook failed, you may need to resolve the issue before"
 466                        warn "you are able to reword the commit."
 467                        exit_with_patch $sha1 1
 468                }
 469                record_in_rewritten $sha1
 470                ;;
 471        edit|e)
 472                comment_for_reflog edit
 473
 474                mark_action_done
 475                do_pick $sha1 "$rest"
 476                warn "Stopped at $sha1... $rest"
 477                exit_with_patch $sha1 0
 478                ;;
 479        squash|s|fixup|f)
 480                case "$command" in
 481                squash|s)
 482                        squash_style=squash
 483                        ;;
 484                fixup|f)
 485                        squash_style=fixup
 486                        ;;
 487                esac
 488                comment_for_reflog $squash_style
 489
 490                test -f "$done" && has_action "$done" ||
 491                        die "Cannot '$squash_style' without a previous commit"
 492
 493                mark_action_done
 494                update_squash_messages $squash_style $sha1
 495                author_script_content=$(get_author_ident_from_commit HEAD)
 496                echo "$author_script_content" > "$author_script"
 497                eval "$author_script_content"
 498                output git reset --soft HEAD^
 499                pick_one -n $sha1 || die_failed_squash $sha1 "$rest"
 500                case "$(peek_next_command)" in
 501                squash|s|fixup|f)
 502                        # This is an intermediate commit; its message will only be
 503                        # used in case of trouble.  So use the long version:
 504                        do_with_author output git commit --no-verify -F "$squash_msg" ||
 505                                die_failed_squash $sha1 "$rest"
 506                        ;;
 507                *)
 508                        # This is the final command of this squash/fixup group
 509                        if test -f "$fixup_msg"
 510                        then
 511                                do_with_author git commit --no-verify -F "$fixup_msg" ||
 512                                        die_failed_squash $sha1 "$rest"
 513                        else
 514                                cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
 515                                rm -f "$GIT_DIR"/MERGE_MSG
 516                                do_with_author git commit --no-verify -e ||
 517                                        die_failed_squash $sha1 "$rest"
 518                        fi
 519                        rm -f "$squash_msg" "$fixup_msg"
 520                        ;;
 521                esac
 522                record_in_rewritten $sha1
 523                ;;
 524        x|"exec")
 525                read -r command rest < "$todo"
 526                mark_action_done
 527                printf 'Executing: %s\n' "$rest"
 528                # "exec" command doesn't take a sha1 in the todo-list.
 529                # => can't just use $sha1 here.
 530                git rev-parse --verify HEAD > "$state_dir"/stopped-sha
 531                ${SHELL:-@SHELL_PATH@} -c "$rest" # Actual execution
 532                status=$?
 533                # Run in subshell because require_clean_work_tree can die.
 534                dirty=f
 535                (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
 536                if test "$status" -ne 0
 537                then
 538                        warn "Execution failed: $rest"
 539                        test "$dirty" = f ||
 540                        warn "and made changes to the index and/or the working tree"
 541
 542                        warn "You can fix the problem, and then run"
 543                        warn
 544                        warn "  git rebase --continue"
 545                        warn
 546                        exit "$status"
 547                elif test "$dirty" = t
 548                then
 549                        warn "Execution succeeded: $rest"
 550                        warn "but left changes to the index and/or the working tree"
 551                        warn "Commit or stash your changes, and then run"
 552                        warn
 553                        warn "  git rebase --continue"
 554                        warn
 555                        exit 1
 556                fi
 557                ;;
 558        *)
 559                warn "Unknown command: $command $sha1 $rest"
 560                if git rev-parse --verify -q "$sha1" >/dev/null
 561                then
 562                        die_with_patch $sha1 "Please fix this in the file $todo."
 563                else
 564                        die "Please fix this in the file $todo."
 565                fi
 566                ;;
 567        esac
 568        test -s "$todo" && return
 569
 570        comment_for_reflog finish &&
 571        shortonto=$(git rev-parse --short $onto) &&
 572        newhead=$(git rev-parse HEAD) &&
 573        case $head_name in
 574        refs/*)
 575                message="$GIT_REFLOG_ACTION: $head_name onto $shortonto" &&
 576                git update-ref -m "$message" $head_name $newhead $orig_head &&
 577                git symbolic-ref \
 578                  -m "$GIT_REFLOG_ACTION: returning to $head_name" \
 579                  HEAD $head_name
 580                ;;
 581        esac && {
 582                test ! -f "$state_dir"/verbose ||
 583                        git diff-tree --stat $orig_head..HEAD
 584        } &&
 585        {
 586                test -s "$rewritten_list" &&
 587                git notes copy --for-rewrite=rebase < "$rewritten_list" ||
 588                true # we don't care if this copying failed
 589        } &&
 590        if test -x "$GIT_DIR"/hooks/post-rewrite &&
 591                test -s "$rewritten_list"; then
 592                "$GIT_DIR"/hooks/post-rewrite rebase < "$rewritten_list"
 593                true # we don't care if this hook failed
 594        fi &&
 595        rm -rf "$state_dir" &&
 596        git gc --auto &&
 597        warn "Successfully rebased and updated $head_name."
 598
 599        exit
 600}
 601
 602do_rest () {
 603        while :
 604        do
 605                do_next
 606        done
 607}
 608
 609# skip picking commits whose parents are unchanged
 610skip_unnecessary_picks () {
 611        fd=3
 612        while read -r command rest
 613        do
 614                # fd=3 means we skip the command
 615                case "$fd,$command" in
 616                3,pick|3,p)
 617                        # pick a commit whose parent is current $onto -> skip
 618                        sha1=${rest%% *}
 619                        case "$(git rev-parse --verify --quiet "$sha1"^)" in
 620                        "$onto"*)
 621                                onto=$sha1
 622                                ;;
 623                        *)
 624                                fd=1
 625                                ;;
 626                        esac
 627                        ;;
 628                3,#*|3,)
 629                        # copy comments
 630                        ;;
 631                *)
 632                        fd=1
 633                        ;;
 634                esac
 635                printf '%s\n' "$command${rest:+ }$rest" >&$fd
 636        done <"$todo" >"$todo.new" 3>>"$done" &&
 637        mv -f "$todo".new "$todo" &&
 638        case "$(peek_next_command)" in
 639        squash|s|fixup|f)
 640                record_in_rewritten "$onto"
 641                ;;
 642        esac ||
 643        die "Could not skip unnecessary pick commands"
 644}
 645
 646# Rearrange the todo list that has both "pick sha1 msg" and
 647# "pick sha1 fixup!/squash! msg" appears in it so that the latter
 648# comes immediately after the former, and change "pick" to
 649# "fixup"/"squash".
 650rearrange_squash () {
 651        # extract fixup!/squash! lines and resolve any referenced sha1's
 652        while read -r pick sha1 message
 653        do
 654                case "$message" in
 655                "squash! "*|"fixup! "*)
 656                        action="${message%%!*}"
 657                        rest="${message#*! }"
 658                        echo "$sha1 $action $rest"
 659                        # if it's a single word, try to resolve to a full sha1 and
 660                        # emit a second copy. This allows us to match on both message
 661                        # and on sha1 prefix
 662                        if test "${rest#* }" = "$rest"; then
 663                                fullsha="$(git rev-parse -q --verify "$rest" 2>/dev/null)"
 664                                if test -n "$fullsha"; then
 665                                        # prefix the action to uniquely identify this line as
 666                                        # intended for full sha1 match
 667                                        echo "$sha1 +$action $fullsha"
 668                                fi
 669                        fi
 670                esac
 671        done >"$1.sq" <"$1"
 672        test -s "$1.sq" || return
 673
 674        used=
 675        while read -r pick sha1 message
 676        do
 677                case " $used" in
 678                *" $sha1 "*) continue ;;
 679                esac
 680                printf '%s\n' "$pick $sha1 $message"
 681                used="$used$sha1 "
 682                while read -r squash action msg_content
 683                do
 684                        case " $used" in
 685                        *" $squash "*) continue ;;
 686                        esac
 687                        emit=0
 688                        case "$action" in
 689                        +*)
 690                                action="${action#+}"
 691                                # full sha1 prefix test
 692                                case "$msg_content" in "$sha1"*) emit=1;; esac ;;
 693                        *)
 694                                # message prefix test
 695                                case "$message" in "$msg_content"*) emit=1;; esac ;;
 696                        esac
 697                        if test $emit = 1; then
 698                                printf '%s\n' "$action $squash $action! $msg_content"
 699                                used="$used$squash "
 700                        fi
 701                done <"$1.sq"
 702        done >"$1.rearranged" <"$1"
 703        cat "$1.rearranged" >"$1"
 704        rm -f "$1.sq" "$1.rearranged"
 705}
 706
 707case "$action" in
 708continue)
 709        # do we have anything to commit?
 710        if git diff-index --cached --quiet HEAD --
 711        then
 712                : Nothing to commit -- skip this
 713        else
 714                if ! test -f "$author_script"
 715                then
 716                        die "You have staged changes in your working tree. If these changes are meant to be
 717squashed into the previous commit, run:
 718
 719  git commit --amend
 720
 721If they are meant to go into a new commit, run:
 722
 723  git commit
 724
 725In both case, once you're done, continue with:
 726
 727  git rebase --continue
 728"
 729                fi
 730                . "$author_script" ||
 731                        die "Error trying to find the author identity to amend commit"
 732                current_head=
 733                if test -f "$amend"
 734                then
 735                        current_head=$(git rev-parse --verify HEAD)
 736                        test "$current_head" = $(cat "$amend") ||
 737                        die "\
 738You have uncommitted changes in your working tree. Please, commit them
 739first and then run 'git rebase --continue' again."
 740                        git reset --soft HEAD^ ||
 741                        die "Cannot rewind the HEAD"
 742                fi
 743                do_with_author git commit --no-verify -F "$msg" -e || {
 744                        test -n "$current_head" && git reset --soft $current_head
 745                        die "Could not commit staged changes."
 746                }
 747        fi
 748
 749        record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
 750
 751        require_clean_work_tree "rebase"
 752        do_rest
 753        ;;
 754skip)
 755        git rerere clear
 756
 757        do_rest
 758        ;;
 759esac
 760
 761git var GIT_COMMITTER_IDENT >/dev/null ||
 762        die "You need to set your committer info first"
 763
 764comment_for_reflog start
 765
 766if test ! -z "$switch_to"
 767then
 768        output git checkout "$switch_to" -- ||
 769                die "Could not checkout $switch_to"
 770fi
 771
 772orig_head=$(git rev-parse --verify HEAD) || die "No HEAD?"
 773mkdir "$state_dir" || die "Could not create temporary $state_dir"
 774
 775: > "$state_dir"/interactive || die "Could not mark as interactive"
 776write_basic_state
 777if test t = "$preserve_merges"
 778then
 779        if test -z "$rebase_root"
 780        then
 781                mkdir "$rewritten" &&
 782                for c in $(git merge-base --all $orig_head $upstream)
 783                do
 784                        echo $onto > "$rewritten"/$c ||
 785                                die "Could not init rewritten commits"
 786                done
 787        else
 788                mkdir "$rewritten" &&
 789                echo $onto > "$rewritten"/root ||
 790                        die "Could not init rewritten commits"
 791        fi
 792        # No cherry-pick because our first pass is to determine
 793        # parents to rewrite and skipping dropped commits would
 794        # prematurely end our probe
 795        merges_option=
 796else
 797        merges_option="--no-merges --cherry-pick"
 798fi
 799
 800shorthead=$(git rev-parse --short $orig_head)
 801shortonto=$(git rev-parse --short $onto)
 802if test -z "$rebase_root"
 803        # this is now equivalent to ! -z "$upstream"
 804then
 805        shortupstream=$(git rev-parse --short $upstream)
 806        revisions=$upstream...$orig_head
 807        shortrevisions=$shortupstream..$shorthead
 808else
 809        revisions=$onto...$orig_head
 810        shortrevisions=$shorthead
 811fi
 812git rev-list $merges_option --pretty=oneline --abbrev-commit \
 813        --abbrev=7 --reverse --left-right --topo-order \
 814        $revisions | \
 815        sed -n "s/^>//p" |
 816while read -r shortsha1 rest
 817do
 818
 819        if test -z "$keep_empty" && is_empty_commit $shortsha1
 820        then
 821                comment_out="# "
 822        else
 823                comment_out=
 824        fi
 825
 826        if test t != "$preserve_merges"
 827        then
 828                printf '%s\n' "${comment_out}pick $shortsha1 $rest" >>"$todo"
 829        else
 830                sha1=$(git rev-parse $shortsha1)
 831                if test -z "$rebase_root"
 832                then
 833                        preserve=t
 834                        for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
 835                        do
 836                                if test -f "$rewritten"/$p
 837                                then
 838                                        preserve=f
 839                                fi
 840                        done
 841                else
 842                        preserve=f
 843                fi
 844                if test f = "$preserve"
 845                then
 846                        touch "$rewritten"/$sha1
 847                        printf '%s\n' "${comment_out}pick $shortsha1 $rest" >>"$todo"
 848                fi
 849        fi
 850done
 851
 852# Watch for commits that been dropped by --cherry-pick
 853if test t = "$preserve_merges"
 854then
 855        mkdir "$dropped"
 856        # Save all non-cherry-picked changes
 857        git rev-list $revisions --left-right --cherry-pick | \
 858                sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
 859        # Now all commits and note which ones are missing in
 860        # not-cherry-picks and hence being dropped
 861        git rev-list $revisions |
 862        while read rev
 863        do
 864                if test -f "$rewritten"/$rev -a "$(sane_grep "$rev" "$state_dir"/not-cherry-picks)" = ""
 865                then
 866                        # Use -f2 because if rev-list is telling us this commit is
 867                        # not worthwhile, we don't want to track its multiple heads,
 868                        # just the history of its first-parent for others that will
 869                        # be rebasing on top of it
 870                        git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
 871                        short=$(git rev-list -1 --abbrev-commit --abbrev=7 $rev)
 872                        sane_grep -v "^[a-z][a-z]* $short" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
 873                        rm "$rewritten"/$rev
 874                fi
 875        done
 876fi
 877
 878test -s "$todo" || echo noop >> "$todo"
 879test -n "$autosquash" && rearrange_squash "$todo"
 880cat >> "$todo" << EOF
 881
 882# Rebase $shortrevisions onto $shortonto
 883#
 884# Commands:
 885#  p, pick = use commit
 886#  r, reword = use commit, but edit the commit message
 887#  e, edit = use commit, but stop for amending
 888#  s, squash = use commit, but meld into previous commit
 889#  f, fixup = like "squash", but discard this commit's log message
 890#  x, exec = run command (the rest of the line) using shell
 891#
 892# These lines can be re-ordered; they are executed from top to bottom.
 893#
 894# If you remove a line here THAT COMMIT WILL BE LOST.
 895# However, if you remove everything, the rebase will be aborted.
 896#
 897EOF
 898
 899if test -z "$keep_empty"
 900then
 901        echo "# Note that empty commits are commented out" >>"$todo"
 902fi
 903
 904
 905has_action "$todo" ||
 906        die_abort "Nothing to do"
 907
 908cp "$todo" "$todo".backup
 909git_sequence_editor "$todo" ||
 910        die_abort "Could not execute editor"
 911
 912has_action "$todo" ||
 913        die_abort "Nothing to do"
 914
 915test -d "$rewritten" || test -n "$force_rebase" || skip_unnecessary_picks
 916
 917output git checkout $onto || die_abort "could not detach HEAD"
 918git update-ref ORIG_HEAD $orig_head
 919do_rest